Option Explicit

'   MsgBox
'  [OK]
Global Const IDOK = 1
'  [Cancel]
Global Const IDCANCEL = 2
'  [Abort]
Global Const IDABORT = 3
'  [Retry]
Global Const IDRETRY = 4
'  [Ignore]
Global Const IDIGNORE = 5
'  [Yes]
Global Const IDYES = 6
'  [No]
Global Const IDNO = 7

Function iInStrRight (iP As Integer, sA, sB As String) As Integer
  ' InStrRight -     ,
  '  InStr,      
  '     .
  '
  ' iP -    
  ' sA -     
  ' sB -  
  Dim iI As Integer
  Dim iTmpP As Integer
  Dim iTmpPos As Integer
  Dim iStrLen As Integer
  '
  iStrLen = Len(sA)
  '
  If Len(sB) = 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iStrLen = 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iP <= 0 Then
    iInStrRight = 0
    Exit Function
  ElseIf iP > iStrLen Then
    iInStrRight = 0
    Exit Function
  End If
  '
  iTmpP = iStrLen - iP + 1
  '
  For iI = iTmpP To 1 Step -1
    iTmpPos = InStr(iI, sA, sB)
    If iTmpPos <> 0 Then
      iInStrRight = iStrLen - iTmpPos
      Exit Function
    End If
  Next iI
End Function

Sub Replace (sS0, sS1, sS2 As String)
  Dim iL As Integer
  Dim iP As Integer
  Dim sT0 As String
  Dim sT1 As String
  '
  iL = Len(sS1)
  iP = 1
  Do
    iP = InStr(iP, sS0, sS1)
    If iP > 0 Then
      sT0 = Mid$(sS0, 1, iP - 1)
      sT1 = Mid$(sS0, iP + iL, Len(sS0))
      sS0 = sT0 + sS2 + sT1
      iP = iP + Len(sS2)
    Else
      Exit Do
    End If
  Loop While True
End Sub

Function sFormatDate (sDt As String) As String
  Dim sT0 As String
  Dim sTd As String
  Dim sTm As String
  Dim sTy As String
  sT0 = sDt
  sTy = sLeftCut(sT0, "-")
  sTm = sLeftCut(sT0, "-")
  sTd = sT0
  sT0 = sTd + "-" + sTm + "-" + sTy
  sFormatDate = sT0
End Function

Function sFormatSP (A As Variant, F As String) As String
  Dim sT As String
  '
  sT = ""
  sT = sT + Space$(Len(F) - Len(Format$(A, F)))
  sT = sT + Format$(A, F)
  sFormatSP = sT
End Function

Function sLeftCut (sA, sB As String) As String
  ' sLeftCut -     
  '     .
  '
  ' sA -  
  ' sB -  
  If Len(sA) = 0 Then
    sLeftCut = ""
    Exit Function
  ElseIf Len(sB) = 0 Then
    sLeftCut = ""
    Exit Function
  ElseIf InStr(sA, sB) = 0 Then
    sLeftCut = ""
    Exit Function
  End If
  '
  sLeftCut = Left$(sA, InStr(sA, sB) - 1)
  sA = Right$(sA, Len(sA) - InStr(sA, sB) - Len(sB) + 1)
End Function

Sub SortStr (sSort As String)
  '    
  '
  Dim sT0 As String
  Dim sT1 As String
  Dim iN As Integer
  Dim iI As Integer
  Dim iFlag As Integer
  Dim sT2() As String
  '
  sT0 = sSort
  iN = 0
  While sT0 <> ""
    sT1 = sLeftCut(sT0, Chr$(13) + Chr$(10))
    iN = iN + 1
  Wend
  '
  ReDim sT2(iN - 1) As String
  '
  sT0 = sSort
  For iI = 0 To iN - 1
    sT2(iI) = sLeftCut(sT0, Chr$(13) + Chr$(10))
  Next iI
  '
  '    
  iFlag = True
  While iFlag
    iFlag = False
    For iI = 0 To iN - 2
      If sT2(iI) > sT2(iI + 1) Then
        Call SwapString(sT2(iI), sT2(iI + 1))
        iFlag = True
      End If
    Next iI
  Wend
  '
  sT0 = ""
  For iI = 0 To iN - 1
    sT0 = sT0 + sT2(iI)
    sT0 = sT0 + Chr$(13) + Chr$(10)
  Next iI
  '
  sSort = sT0
End Sub

Function sRightCut (sA, sB As String) As String
  ' sRightCut -     
  '     .
  '
  ' S1 -  
  ' S2 -  
  If Len(sA) = 0 Then
    sRightCut = ""
    Exit Function
  ElseIf Len(sB) = 0 Then
    sRightCut = ""
    Exit Function
  ElseIf InStr(sA, sB) = 0 Then
    sRightCut = ""
    Exit Function
  End If
  '
  sRightCut = Right$(sA, iInStrRight(1, sA, sB) - Len(sB) + 1)
  sA = Left$(sA, Len(sA) - iInStrRight(1, sA, sB) - 1)
End Function

Sub SwapString (sA, sB As String)
  ' SwapString -    .
  '
  ' sA -  
  ' sB -  
  Dim sT As String
  '
  sT = sA
  sA = sB
  sB = sT
End Sub

